# Imports
from flask import Flask, request, jsonify, json
import random
from flask_cors import CORS
from flask_socketio import SocketIO
from GPIOmct.mijnmcp import MijnMcp
from GPIOmct.lcd import LCD
from netifaces import AF_INET, AF_INET6, AF_LINK, AF_PACKET, AF_BRIDGE
import netifaces as ni
from RPi import GPIO
import time
import threading
import subprocess
sendData = True
location = "x"

# Custom imports
from DP1Database import Database

# Start app
app = Flask(__name__)
CORS(app)
socketio = SocketIO(app)

conn = Database(app=app, user='mct', password='Goem123!',
                db='muziek_final', host='localhost', port=3306)
endpoint = '/api/v1'


mcp = MijnMcp()
lcd = LCD()
bb = 21
is_running = False

## FOR BREAKBEAM AND MUSIC ONLINE TOOL

def call_omxplayer():
    global location
    global is_running
    print("playing " + location)
    pid = subprocess.call(['omxplayer', location], stderr=subprocess.PIPE, stdout=subprocess.PIPE)
    is_running = False

def play_song():
    global location
    global is_running
    global insert
    if not is_running:
        song_thread = threading.Thread(target=call_omxplayer, args=())
        song_thread.start()
        is_running = True
        insert = True

timerstarted = False
def refreshData():
    print("refresh")
    global timerstarted
    global sendData
    global location
    global insert
    print(timerstarted)
    timerstarted = True
    while timerstarted:
        print("hallokes")
        ldr = MijnMcp.read_channel(mcp, 0)
        temp = MijnMcp.read_channel(mcp, 1)
        bb = MijnMcp.read_channel(mcp, 2)
        genre = conn.get_data(
            "SELECT * FROM musicgenre left join songs as s ON musicgenre.GenreID = s.SongGenreID left join songlocations as sl on s.SongLocationID = sl.SongLocationID WHERE MaxLight >= %s AND %s >= MinLight AND MaxTemp >= %s AND %s >= MinTemp ORDER BY RAND() LIMIT 1",
            [ldr, ldr, temp, temp])
        if bb <= 25:
            location = genre[0]["SongLocation"]
            play_song()
            print("Playing")
            if insert == True:
                conn.set_data(
                    "INSERT INTO sensorhistory (SensorValue,SensorID, Date) VALUES (%s,(SELECT ID from sensor AS s WHERE s.Sensor = 'LDR'), CURRENT_TIMESTAMP)",
                    ldr)
                conn.set_data(
                    "INSERT INTO sensorhistory (SensorValue,SensorID, Date) VALUES (%s,(SELECT ID from sensor AS s WHERE s.Sensor = 'Temperatuur'), CURRENT_TIMESTAMP)",
                    temp)
            insert = False
        print(bb)
        time.sleep(0.5)
@socketio.on('timer')
def timer(state):
    print("timerprint")
    global timerstarted
    print(state)
    if isinstance(state, bool):
        if state & timerstarted:
            print("state1")
            ldr = MijnMcp.read_channel(mcp, 0)
            temp = MijnMcp.read_channel(mcp, 1)
            bb = MijnMcp.read_channel(mcp, 2)
            genre = conn.get_data(
                "SELECT * FROM musicgenre left join songs as s ON musicgenre.GenreID = s.SongGenreID left join songlocations as sl on s.SongLocationID = sl.SongLocationID WHERE MaxLight >= %s AND %s >= MinLight AND MaxTemp >= %s AND %s >= MinTemp ORDER BY RAND() LIMIT 1",
                [ldr, ldr, temp, temp])
            if bb <= 25:
                location = genre[0]["SongLocation"]
                play_song()
                print("Playing")
                conn.set_data(
                    "INSERT INTO sensorhistory (SensorValue,SensorID, Date) VALUES (%s,(SELECT ID from sensor AS s WHERE s.Sensor = 'LDR'), CURRENT_TIMESTAMP)",
                    ldr)
                conn.set_data(
                    "INSERT INTO sensorhistory (SensorValue,SensorID, Date) VALUES (%s,(SELECT ID from sensor AS s WHERE s.Sensor = 'Temperatuur'), CURRENT_TIMESTAMP)",
                    temp)
        elif state == False & timerstarted:
            timerstarted = False
            print("gestopt")

        elif state == True and timerstarted == False:
            thread = threading.Thread(target=refreshData)
            thread.start()
            print("gestart")
        else:
            pass
    else:
        print("geen bool")
        try:
            state = bool(state)
            print('ik zit hier')
            if state & timerstarted:
                print("state1")
            elif not state & timerstarted:
                print("state2")
                timerstarted = False
            elif state and not timerstarted:
                print("state3")
                thread = threading.Thread(target=refreshData)
                thread.start()
            else:
                print("state4")
                pass

        except:
            print("unable to convert")


# BACKEND
# Deze route wordt gebruikt voor het ophalen van de sensors.


@app.route(endpoint + '/sensors', methods=['GET'])
def sensors():
    if request.method == 'GET':
        sensors = conn.get_data(
            "SELECT * FROM sensor")
        return jsonify(sensors), 200

@app.route(endpoint + '/songs', methods=['GET'])
def song():
    if request.method == 'GET':
        song = conn.get_data(
            "SELECT * FROM songs left join music m on songs.SongNameID = m.SongID left join musicgenre m2 on songs.SongGenreID = m2.GenreID")
        return jsonify(song), 200

@app.route(endpoint + '/sensorshistory', methods=['GET'])
def sensorshistory():
    if request.method == 'GET':
        sensorshistory = conn.get_data(
            "SELECT * FROM sensorhistory ORDER BY idSensorHistoryID DESC LIMIT 10")
        return jsonify(sensorshistory), 200

# Deze route wordt gebruikt voor het ophalen van het genre
@app.route(endpoint + '/genre', methods=['GET'])
def genre():
    ldr = MijnMcp.read_channel(mcp, 0)
    temp = MijnMcp.read_channel(mcp, 1)
    print(ldr)
    print(temp)
    if request.method == 'GET':
        genre = conn.get_data(
            "SELECT * FROM musicgenre WHERE MaxLight >= %s AND %s >= MinLight AND MaxTemp >= %s AND %s >= MinTemp LIMIT 1", [ldr, ldr, temp, temp])
        return jsonify(genre), 200

# Deze route wordt gebruikt voor het ophalen van de naam van het lied.
@app.route(endpoint + '/songs/<name>', methods=['GET'])
def songs(name):
    if request.method == 'GET':
        songs = conn.get_data(
            "SELECT SongArtist, SongName FROM music AS m RIGHT JOIN songsplayed AS sp ON m.SongID = sp.SongID WHERE SongName LIKE %s", name)
        return jsonify(songs), 200


@socketio.on("PlaySong")
def SaveSensors():
    genres = []
    ldr = MijnMcp.read_channel(mcp, 0)
    tempSensor = MijnMcp.read_channel(mcp, 1)
    new_sensorhistoryLDR = conn.set_data(
        "INSERT INTO sensorhistory (SensorValue,SensorID, Date) VALUES (%s,(SELECT ID from sensor AS s WHERE s.Sensor = 'LDR'), CURRENT_TIMESTAMP)",
        ldr)
    new_sensorhistoryTempSensor = conn.set_data(
        "INSERT INTO sensorhistory (SensorValue,SensorID, Date) VALUES (%s,(SELECT ID from sensor AS s WHERE s.Sensor = 'Temperatuur'), CURRENT_TIMESTAMP)",
        tempSensor)
    genre = conn.get_data(
        "SELECT MuziekGenre FROM musicgenre AS m RIGHT JOIN songs AS s ON m.GenreID = s.SongGenreID WHERE MaxLight >= %s AND %s >= MinLight AND MaxTemp >= %s AND %s >= MinTemp LIMIT 1", [ldr, ldr, tempSensor, tempSensor])
    # verwittig frontend van aanpassing
    # socketio.emit('new-insert', {'LDR': ldr, 'TempSensor': tempSensor})
    genres = jsonify(genre)
    socketio.emit('new-select', {'genres': genres})
    return jsonify(idSensorHistoryID=new_sensorhistoryTempSensor ),jsonify(idSensorHistoryID=new_sensorhistoryLDR ), jsonify(genre), 201

def init():
    GPIO.setmode(GPIO.BCM)
    GPIO.setup(21, GPIO.IN)
    GPIO.add_event_detect(21, GPIO.BOTH, callback=lambda x: play_song(), bouncetime=10)
    LCD()

def omzetten_volt(waarde):
    volts = waarde / 1024
    temperature = volts / (10.0 / 1000) * 3.3
    return temperature

def omzetten_procent(waarde):
    return waarde / 1024

try:
    # Start app
    if __name__ == '__main__':
        init()
        lcd.reset_LCD()
        message = ni.ifaddresses('wlan0')[AF_INET][0]['addr']
        LCD.write_message(lcd, message)
        time.sleep(0.01)
        print("SE")
        socketio.run(app, host="0.0.0.0", port=5000)

except KeyboardInterrupt as ex:
    print("Program has been stopped")
finally:
    GPIO.cleanup()